unit AgentMainFrm;

interface

uses
  Windows, Messages,activex, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, AgentObjects_TLB;

type
  TfrmAgentMain = class(TForm)
    Agent1: TAgent;
    btnProperties: TButton;
    Memo1: TMemo;
    btnAgentSpeaktoMe: TButton;
    Memotext: TMemo;
    Label1: TLabel;
    Memo2: TMemo;
    ListBox1Actions: TListBox;
    Label2: TLabel;
    btnLoadAgent: TButton;
    ComboBoxAgents: TComboBox;
    btnExample: TButton;
    btnThink: TButton;
    procedure btnPropertiesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Agent1Show(Sender: TObject; const CharacterID: WideString;
      Cause: Smallint);
    procedure Agent1Hide(Sender: TObject; const CharacterID: WideString;
      Cause: Smallint);
    procedure Agent1DblClick(Sender: TObject;
      const CharacterID: WideString; Button, Shift, x, y: Smallint);
    procedure Agent1RequestComplete(Sender: TObject;
      const Request: IDispatch);
    procedure btnLoadAgentClick(Sender: TObject);
    procedure ListBox1ActionsDblClick(Sender: TObject);
    procedure btnAgentSpeaktoMeClick(Sender: TObject);
    procedure btnExampleClick(Sender: TObject);
    procedure btnThinkClick(Sender: TObject);


  private
    { Private declarations }
    Agent:IAgentCtlCharacterEx;
    AgentRequest:IAgentCtlRequest;
    AgentRequestSpeech:IAgentCtlRequest;
    procedure Verbs;
    procedure Log(const aLogline: string);
  public
    { Public declarations }
  end;

var
  frmAgentMain: TfrmAgentMain;

implementation

{$R *.DFM}

procedure TfrmAgentMain.btnPropertiesClick(Sender: TObject);
begin

Agent1.ShowDefaultCharacterProperties;
end;

procedure TfrmAgentMain.FormCreate(Sender: TObject);
begin
Agent1.Connected:=true;
//Agent1.Characters.Load('Merlin','Merlin.acs');
//Agent:=Agent1.Characters.Character('Merlin');
end;

procedure TfrmAgentMain.Agent1Show(Sender: TObject;
  const CharacterID: WideString; Cause: Smallint);
begin
memo1.lines.Add(format('Name:%S,Cause%D',[CharacterID,Cause]))
end;

procedure TfrmAgentMain.Agent1Hide(Sender: TObject;
  const CharacterID: WideString; Cause: Smallint);
begin
memo1.lines.Add(format('Name:%S,Cause%D',[CharacterID,Cause]));
end;

procedure TfrmAgentMain.Agent1DblClick(Sender: TObject;
  const CharacterID: WideString; Button, Shift, x, y: Smallint);
begin
agent.Speak('StopThat','')
end;

procedure TfrmAgentMain.Agent1RequestComplete(Sender: TObject;
  const Request: IDispatch);
begin
if AgentRequestSpeech=Request then
 begin
   memo1.lines.add('Finished Speaking');
 end
 else
 if AgentRequestSpeech=Request then
 begin
    memo1.lines.add('Finished Other');

 end;
end;




procedure TfrmAgentMain.Verbs;
var
Fetch: Cardinal;
V: OleVariant;
AnimationNames:IAgentCtlAnimationNames;
aEnum:IEnumVariant;
begin
    AnimationNames := agent.AnimationNames;
    aEnum          := AnimationNames.Enum as IEnumVariant;
    AEnum.Reset;
    ListBox1Actions.Items.Clear;
    repeat
      AEnum.Next(1,V, Fetch);
      if VarToStr(V) <> EmptyStr then
        ListBox1Actions.Items.Add(V);
    until Fetch = 0;

end;




procedure TfrmAgentMain.btnLoadAgentClick(Sender: TObject);
begin
//Agent1.Characters.Unload(ComboBoxAgents.text);
Agent1.Characters.Load(ComboBoxAgents.text,ComboBoxAgents.text+'.acs');
Agent:=Agent1.Characters.Character(ComboBoxAgents.text);
Verbs;

btnThink.Enabled:=true;
btnAgentSpeaktoMe.Enabled:=true;
btnExample.Enabled:=true;

end;

procedure TfrmAgentMain.ListBox1ActionsDblClick(Sender: TObject);
var
Command:String;
begin
if ListBox1Actions.ItemIndex>-1 then
 begin
  agent.show(0);
  Command:=ListBox1Actions.items[ListBox1Actions.ItemIndex];
  AgentRequest:=agent.Play(Command);
 end;


end;



procedure TfrmAgentMain.btnExampleClick(Sender: TObject);
var
k:integer;
aComp:Tcomponent;
aControl:TControl;
x,y:integer;
begin
for x:=0 to frmAgentMain.ComponentCount-1 do
  begin
   aComp:=frmAgentMain.Components[x];
    log(aComp.Name);
    agent.show(0);
    if aComp is TControl then
      begin
      aControl:=TControl(aComp);
      agent.MoveTo(aControl.Left,aControl.Top,1) ;
      agent.Speak(aControl.Name,'');
      end;
  end;
end;

procedure TfrmAgentMain.Log(const aLogline :string);
begin
 memo1.Lines.Add(aLogline)
end;


//{ Get a list of all animations (for the play method) existing for a character}
//procedure GetAnimationList(const IAChar: IAgentCtlCharacterEx; const Ts: TStrings);
//{ IAChar : the character like  Agent.Characters.Character('Genie')
// Ts : the TStrings to be filled with the list of his available animations}
//const
// { avoid a use clause on OLE2 }
// IID_IEnumVariant: TGUID = (
//   D1:$00020404;D2:$0000;D3:$0000;D4:($C0,$00,$00,$00,$00,$00,$00,$46));
//var
// pEnum: IEnumVARIANT;
// vAnimName: OleVARIANT;
// dwRetrieved: Cardinal;
// hRes: HResult;
//begin
// ts.BeginUpdate;
// try
//   ts.Clear;
//   hRes := IAChar.AnimationNames.enum.QueryInterface(IID_IEnumVARIANT, pEnum);
//   if S_Ok = hRes then begin
//     while TRUE do begin
//       hRes := pEnum.Next(1, vAnimName, dwRetrieved);
//       if S_OK<>hRes then
//         break;
//       ts.add(vAnimName);
//     end;
//   end;
// finally
//   ts.EndUpdate;
// end;
//end;

procedure TfrmAgentMain.btnAgentSpeaktoMeClick(Sender: TObject);
begin
agent.Show(0);
AgentRequestSpeech:=agent.Speak(Memotext.lines.text,'');
end;

procedure TfrmAgentMain.btnThinkClick(Sender: TObject);
begin
agent.Show(0);
agent.Think(Memotext.lines.text);
end;

end.
